SystemOrganization addCategory: #'OCMS-Interface'!

WAComponent subclass: #CoursewareDetailsView
	instanceVariableNames: 'courseware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:12'!
back
	self answer.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:44'!
courseware
	^courseware.! !

!CoursewareDetailsView methodsFor: 'accessing' stamp: 'has 6/29/2013 15:43'!
courseware: aCourseware
	courseware:= aCourseware.! !

!CoursewareDetailsView methodsFor: 'rendering' stamp: 'has 6/29/2013 19:17'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: courseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Back to Coursewares'.
	html break.
	html table:[
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Id'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Description'.
						html tableData: courseware description.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Summary'.
						html tableData: courseware summary.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Courseware type'.
						html tableData: courseware coursewareType.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Owner'.
						html tableData: courseware owner username.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Reference'.
						html tableData: courseware reference.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Tag'.
						html tableData: [courseware tagString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Course'.
						html tableData: [courseware courseString.]].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Author'.
						html tableData: courseware authorString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Created at:'.
						html tableData: courseware creationDateTime asTimeStamp.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Modified at:'.
						html tableData: courseware modificationDateTime.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Cataloguing data'.
						html tableData: courseware cataloguingData.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'License'.
						html tableData: courseware license asString.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'File name'.
						html tableData: courseware file.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Size'.
						html tableData: courseware size.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'No. downloads'.
						html tableData: courseware downloadCounter.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Enabled'.
						html tableData: courseware isEnabled.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Write users'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Rating score'.
						html tableData: courseware calculateRatingScore.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Download'.
						html tableData: courseware id.].
		html tableRow:[
						(html tableHeading) align:'left'; with: 'Comments'.
						html tableData: courseware id.].
			].
	html break.
	html heading level: 3;
		with: 'Comments'.
	html table:[ courseware comment do: [:each | 
		html tableRow:[
						(html tableHeading) align:'left'; with: 'User'.
						html tableData: (each login),' - ',(each dateAndTime asTimeStamp),String cr,(each text).].]
		].! !

WAComponent subclass: #CoursewareListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 11:14'!
back
	self answer.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 15:07'!
coursewareDetails: aCourseware on: html
	
	html heading level: 1; 
		with: aCourseware title.
	html space.
	html anchor
		callback: [self back];
		with: 'Coursewares'.! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 14:58'!
renderContentOn: html
	"I render the list of coursewares"

	html heading level: 1;
				with: 'Coursewares'.
	html break.
	html anchor
		callback: [self back];
		with: 'Home'.
	html unorderedList: [self renderItemsOn: html].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:05'!
renderItem: aCourseware on: html
	
	html listItem
		with: [html text: aCourseware title.
				html space.
				html anchor
					callback:[self showCoursewareDetails: aCourseware];
					with: 'details'.
				html space.
				html anchor
					callback:[self editCourseware: aCourseware];
					with: 'edit'.
				].! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 13:25'!
renderItemsOn: html
	| coursewareList batchedList coursewareTitleList selection |
	coursewareList:= Coursewares getAll.
	coursewareList do:[:each | self renderItem: each on: html].
	"coursewareTitleList :=  OrderedCollection new.
	coursewareList do:[:each | coursewareTitleList add: each title]."
	"batchedList := WABatchedList new.
	batchedList items: coursewareTitleList asArray.
	batchedList batchSize: 10."
	"batchedList renderContentOn: html."
	"selection:= WABatchSelection items: coursewareList link: #id text: #title.
	selection batchSize: 20.
	selection onAnswer: [:item | self renderItem: item on:html]. 
	html render: selection."! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 16:12'!
showCoursewareDetails
	self call: (CoursewareDetailsView new).! !

!CoursewareListView methodsFor: 'rendering' stamp: 'has 6/29/2013 17:04'!
showCoursewareDetails: aCourseware
	| coursewareDV |
	coursewareDV:=CoursewareDetailsView new.
	coursewareDV courseware: aCourseware.
	self call: (coursewareDV).! !

WAComponent subclass: #OCMSHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Interface'!

!OCMSHome class methodsFor: 'root' stamp: 'monnacs 6/26/2013 21:06'!
canBeRoot

 
^true! !

!OCMSHome class methodsFor: 'class initialization' stamp: 'has 6/28/2013 19:34'!
initialize
	WAAdmin register: self asApplicationAt: 'ocms'.! !

!OCMSHome methodsFor: 'rendering' stamp: 'has 6/29/2013 11:00'!
renderContentOn: html
	"I render everything by calling html"
 
html heading level: 1; with: 'Open Courseware Management System'.
    html text: 'A system to store and share open courseware to academic institutions.'.

html div
	class: 'menu';
	with: [
		html heading level: 3; with: 'Log In.'.].
	
html space.

html anchor
	"url: 'http://localhost:8080/coursewares';"
	callback: [self showCoursewareListView];
	with: 'Courseware'.! !

!OCMSHome methodsFor: 'rendering' stamp: 'has 6/29/2013 10:57'!
showCoursewareListView
	self call: (CoursewareListView new).! !

!OCMSHome methodsFor: 'updating' stamp: 'monnacs 6/26/2013 22:02'!
updateRoot: anHtmlRoot
    super updateRoot: anHtmlRoot.
    anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css'! !
OCMSHome initialize!
